/*
 *	Sherlock Library -- Object Tree Scanning
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>

#include "lib.h"
#include "string.h"

void
scan_obj_tree(byte *base, void (*func)(ulg oid, byte *name))
{
  DIR *d, *g, *h;
  struct dirent *dd, *gg, *hh;
  byte dirname[32], subname[32], objname[32], digbuf[10];
  uns oid;

  if (! (d = opendir(base)))
    die("Unable to open object directory `%s'", base);
  while (dd = readdir(d))
    {
      if (!Cxdigit(dd->d_name[0]) || !Cxdigit(dd->d_name[1]) || dd->d_name[2])
	continue;
      sprintf(dirname, "%s/%s", base, dd->d_name);
      if (! (g = opendir(dirname)))
	{
	  log(L_ERROR "scan_obj_tree: readdir returned unreadable dir %s", dirname);
	  continue;
	}
      while (gg = readdir(g))
	{
	  if (!Cxdigit(gg->d_name[0]) || !Cxdigit(gg->d_name[1]) || gg->d_name[2])
	    continue;
	  sprintf(subname, "%s/%s", dirname, gg->d_name);
	  if (! (h = opendir(subname)))
	    {
	      log(L_ERROR "scan_obj_tree: readdir returned unreadable dir %s", subname);
	      continue;
	    }
	  while (hh = readdir(h))
	    {
	      if (strlen(hh->d_name) != 4 || !Cxdigit(hh->d_name[0]) || !Cxdigit(hh->d_name[1])) /* Should be enough */
		continue;
	      sprintf(objname, "%s/%s", subname, hh->d_name);
	      sprintf(digbuf, "%s%s%s", dd->d_name, gg->d_name, hh->d_name);
	      sscanf(digbuf, "%x", &oid);
	      func(oid, objname);
	    }
	  closedir(h);
	}
      closedir(g);
    }
  closedir(d);
}
