/*
 *	Sherlock Database Builder -- Show Word Counts
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

#include <lib/lib.h>
#include <lib/searchdb.h>
#include <lib/fastbuf.h>

#define BUFSIZE 65536

int
main(int argc, char **argv)
{
  int c, p;
  byte x[256];
  ulg l, pos;
  struct fastbuf *fi;
  uns mic = 0;

  initlog(argv[0]);
  if (argc != 2 && argc != 3)
    die("Usage: countwords <word-list-after-sword> [<minimum-count>]");
  if (argc > 2)
    mic = atol(argv[2]);
  fi = bopen(argv[1], O_RDONLY, BUFSIZE);

  for(;;)
    {
      p = 0;
      pos = btell(fi);
      do
	{
	  c = bgetc(fi);
	  if (c < 0)
	    goto done;
	  x[p++] = c;
	}
      while (c);
      l = bgetl(fi);
      bseek(fi, l*6, SEEK_CUR);
      if (l > mic)
	printf("%7d\t%s  [%08x]\n", l, x, pos);
    }

done:
  bclose(fi);
  return 0;
}
