/*
 *	Sherlock Search Engine -- Administration Commands
 *
 *	(c) 1997 Martin Mares, <mj@atrey.karlin.mff.cuni.cz>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sherlock.h"

struct command {
  char *name;
  void (*handler)(int argc, byte **argv);
  int argmin, argmax, passwd;
};

static struct command cmds[] = {
  { "rescan",	pseudo_rescan,	0, 0, 1 },
  { NULL,	NULL,		0, 0, 0 }
};

void
do_command(struct query *q)
{
  byte *c = q->cmd;
  byte *words[16], **argv;
  int argc;
  struct command *cmd = cmds;

  argc = wordsplit(c, words, sizeof(words)/sizeof(byte *));
  if (argc <= 0)
    {
      add_qr("-109 Malformed command");
      return;
    }
  argv = words;
  argc--;
  while (cmd->name)
    {
      if (!strcasecmp(cmd->name, argv[0]))
	{
	  argv++;
	  if (cmd->passwd)
	    {
	      if (!argc || strcmp(control_password, argv[0]))
		{
		  add_qr("-109 Invalid control password");
		  log(L_WARN "`%s' used instead of control password", argv[0]);
		  return;
		}
	      argc--, argv++;
	    }
	  if (argc < cmd->argmin || argc > cmd->argmax)
	    {
	      add_qr("-109 Invalid number of parameters");
	      return;
	    }
	  cmd->handler(argc, argv);
	  return;
	}
      cmd++;
    }
  add_qr("-109 Unknown control command");
}
